Index: cards/CMS_PhaseII/CMS_PhaseII_0PU_v02.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_0PU_v02.tcl	(revision 930d28283fccdca2950c3f6558530333bdaeab1e)
+++ cards/CMS_PhaseII/CMS_PhaseII_0PU_v02.tcl	(revision e3938bbdd66025f2a78f6c925fb215d7fc0dad52)
@@ -53,4 +53,7 @@
   RunPUPPIMerger
   RunPUPPI
+
+  EFlowFilterPuppi
+  EFlowFilterCHS
 
   PhotonFilter
@@ -828,4 +831,34 @@
 }
 
+
+######################
+# EFlowFilterPuppi
+######################
+
+module PdgCodeFilter EFlowFilterPuppi {
+  set InputArray RunPUPPI/PuppiParticles
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
+######################
+# EFlowFilterCHS
+######################
+
+module PdgCodeFilter EFlowFilterCHS {
+  set InputArray EFlowMergerCHS/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
+
 ###################
 # Missing ET merger
@@ -1161,5 +1194,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   # output array
@@ -1192,5 +1225,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   # output array
@@ -1257,6 +1290,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
-  #set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   set OutputArray electrons
@@ -1278,5 +1310,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   set OutputArray electrons
@@ -1391,5 +1423,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   set OutputArray muons
@@ -1409,5 +1441,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   set OutputArray muons
Index: cards/CMS_PhaseII/CMS_PhaseII_140PU_v02.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_140PU_v02.tcl	(revision 930d28283fccdca2950c3f6558530333bdaeab1e)
+++ cards/CMS_PhaseII/CMS_PhaseII_140PU_v02.tcl	(revision e3938bbdd66025f2a78f6c925fb215d7fc0dad52)
@@ -53,4 +53,7 @@
   RunPUPPIMerger
   RunPUPPI
+
+  EFlowFilterPuppi
+  EFlowFilterCHS
 
   PhotonFilter
@@ -828,4 +831,34 @@
 }
 
+######################
+# EFlowFilterPuppi
+######################
+
+module PdgCodeFilter EFlowFilterPuppi {
+  set InputArray RunPUPPI/PuppiParticles
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
+######################
+# EFlowFilterCHS
+######################
+
+module PdgCodeFilter EFlowFilterCHS {
+  set InputArray EFlowMergerCHS/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
+
+
 ###################
 # Missing ET merger
@@ -1161,5 +1194,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   # output array
@@ -1192,5 +1225,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   # output array
@@ -1257,6 +1290,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
-  #set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   set OutputArray electrons
@@ -1278,5 +1310,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   set OutputArray electrons
@@ -1391,5 +1423,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   set OutputArray muons
@@ -1409,5 +1441,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   set OutputArray muons
Index: cards/CMS_PhaseII/CMS_PhaseII_200PU_v02.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_200PU_v02.tcl	(revision 930d28283fccdca2950c3f6558530333bdaeab1e)
+++ cards/CMS_PhaseII/CMS_PhaseII_200PU_v02.tcl	(revision e3938bbdd66025f2a78f6c925fb215d7fc0dad52)
@@ -53,4 +53,7 @@
   RunPUPPIMerger
   RunPUPPI
+
+  EFlowFilterPuppi
+  EFlowFilterCHS
 
   PhotonFilter
@@ -828,4 +831,33 @@
 }
 
+######################
+# EFlowFilterPuppi
+######################
+
+module PdgCodeFilter EFlowFilterPuppi {
+  set InputArray RunPUPPI/PuppiParticles
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
+######################
+# EFlowFilterCHS
+######################
+
+module PdgCodeFilter EFlowFilterCHS {
+  set InputArray EFlowMergerCHS/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
+
 ###################
 # Missing ET merger
@@ -1161,5 +1193,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   # output array
@@ -1192,5 +1224,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   # output array
@@ -1257,6 +1289,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
-  #set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   set OutputArray electrons
@@ -1278,5 +1309,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   set OutputArray electrons
@@ -1391,5 +1422,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilterPuppi/eflow
 
   set OutputArray muons
@@ -1409,5 +1440,5 @@
 
   # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilterCHS/eflow
 
   set OutputArray muons
Index: cards/FCC/FCChh_PileUp.tcl
===================================================================
--- cards/FCC/FCChh_PileUp.tcl	(revision 930d28283fccdca2950c3f6558530333bdaeab1e)
+++ cards/FCC/FCChh_PileUp.tcl	(revision e3938bbdd66025f2a78f6c925fb215d7fc0dad52)
@@ -767,5 +767,5 @@
 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilter/eflow
 
   # output array
@@ -795,5 +795,5 @@
 module Isolation ElectronIsolation {
   set CandidateInputArray ElectronFilter/electrons
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray electrons
@@ -819,5 +819,5 @@
 module Isolation MuonIsolation {
   set CandidateInputArray MuonMomentumSmearing/muons
-  set IsolationInputArray RunPUPPI/PuppiParticles
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray muons
